;TIP1051B.LSP:  GETLAY.LSP      Get Layer     (C)1994, Michel Chayer

;;------------------------------------------------ROUTINE----------
(defun getlco (/ XX LAY)
   (setq LLIST '())
   (setq XX T)
   (while (setq LAY (tblnext "LAYER" XX))
      (setq LLIST (append LLIST (list (cdr(assoc 2 LAY)))))
      (setq XX nil)
   );while
   (if (<= (length LLIST) (getvar "maxsort"))
      (setq LLIST (acad_strlsort LLIST))      
   );if
);end defun
;;------------------------------------------------ROUTINE----------
(defun layli (VALN)
   (set_tile "error" "")
   (setq LNOM (nth (atoi VALN) LLIST))
   (set_tile "EDITLA" LNOM)
);end defun
;;------------------------------------------------ROUTINE----------
(defun laedit (VAL)
   (set_tile "error" "")
   (setq VAL (strcase VAL))
   (if (member VAL LLIST)
      (setq LNOM VAL)
      (progn
         (set_tile "error" "Layer not available.")
         (mode_tile "EDITLA" 2)
      );progn
   );if
);defun
;;------------------------------------------------ROUTINE----------
(defun siok ()
   (if (= (get_tile "error") "")
      (done_dialog 1)
   );if
);defun
;;-----------------------------------------MAIN PROGRAM------
(defun getlay (/ LLIST XX LAY VALN VAL DCLID)
   (GETLCO)
   (setq DCLID (load_dialog "GETLAY.DCL"))
   (if (not (new_dialog "GETLAY" DCLID))
      (progn
         (alert "File GETLAY.DCL not found.")
         (EXIT)
      );progn
   );if
   (set_tile "COUCOU" (getvar "clayer"))
   (setq LNOM (getvar "clayer"))              
   (start_list "LAYLIS")
   (mapcar 'add_list LLIST)                   
   (end_list)
   (set_tile "EDITLA" (getvar "clayer"))
   (action_tile "LAYLIS" "(LAYLI $value)")
   (action_tile "EDITLA" "(LAEDIT $value)")
   (action_tile "accept" "(SIOK)")
   (action_tile "cancel" "(setq LNOM nil)(done_dialog 0)")
   (if (= (start_dialog) 1)                   
      (set_tile "EDITLA" LNOM)
   );if
   LNOM
);defun getlay.lsp
